#include <stdlib.h>

extern char _end;

static char *next = &_end;

#define BUSY 1

void *
malloc(size_t len)
{
  void *res;

  /* Align.  */
  len = (len + 3) & ~3U;

  /* Try to find a free block.  */
  res = &_end;
  while (res != next) {
    /* Read block length.  */
    unsigned l = *(unsigned *)res;

    /* Get block start address.  */
    res += sizeof (unsigned);

    /* If block is free and if length match, return it.  */
    if (l == len)
      return res;

    /* Next block.  */
    res += l & ~BUSY;
  }

  /* No free block.  */
  *(unsigned *)next = len | BUSY;
  res = next + sizeof (unsigned);
  next = res + len;
  
  return res;
}

void free(void *ptr)
{
  if (ptr == NULL)
    return;

  /* Just clear the busy bit.  */
  ptr -= sizeof (unsigned);
  *(unsigned *)ptr = *(unsigned *)ptr & ~BUSY;
}
